﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace MidiKeyboard
{
    class playSound
    {
        [DllImport("winmm.dll", SetLastError = true,
            CallingConvention = CallingConvention.Winapi)]
        static extern bool PlaySound(string pszSound,
                                     IntPtr hMod,
                                     eSndFlags sf);

        public bool playing = false;

        //  flag values for SoundFlags argument on PlaySound
        public enum eSndFlags : int
        {
            SND_SYNC = 0x0000,          // play synchronously
                                        // (default)
            SND_ASYNC = 0x0001,         // play asynchronously
            SND_NODEFAULT = 0x0002,     // silence (!default)
                                        // if sound not found
            SND_MEMORY = 0x0004,        // pszSound points to
                                        // a memory file
            SND_LOOP = 0x0008,          // loop the sound until
                                        // next sndPlaySound
            SND_NOSTOP = 0x0010,        // don't stop any
                                        // currently playing
                                        // sound

            SND_NOWAIT = 0x00002000,    // don't wait if the
                                        // driver is busy
            SND_ALIAS = 0x00010000,     // name is a Registry
                                        // alias
            SND_ALIAS_ID = 0x00110000,  // alias is a predefined
                                        // ID
            SND_FILENAME = 0x00020000,  // name is file name
            SND_RESOURCE = 0x00040004,  // name is resource name
                                        // or atom
            SND_PURGE = 0x0040,         // purge non-static
                                        // events for task
            SND_APPLICATION = 0x0080,   // look for application-
                                        // specific association
        }

        // play predefined sounds
        public void play(string file)
        {
            try
            {
                if (!PlaySound(file, IntPtr.Zero,
                               eSndFlags.SND_FILENAME |
                               eSndFlags.SND_ASYNC |
                               eSndFlags.SND_LOOP))
                {
                    MessageBox.Show("file not found", "WAV Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                else
                {
                    playing = true;
                }
            }
            catch
            {
                int err = Marshal.GetLastWin32Error();
                if (err != 0)
                {
                    MessageBox.Show(err.ToString(), "WAV Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        // stop playing sound
        public void stop()
        {
            PlaySound(null, IntPtr.Zero, eSndFlags.SND_PURGE);
            playing = false;
        }
    }
}
